source("clustercompare.R")
library("ecp")
library("mvtnorm")
for (S in c(100, 200, 300)) {
  set.seed(2012)
  er1 <- er2 <- er3 <- matrix(0, nrow = 5, ncol = 1000)
  mem <- rep(1:(3 * S/10), rep(10, 3 * S/10))

  correct <- rep(c(1, 2, 3), rep(S, 3))
  Acorrect <- rep(c(1, 2, 1), rep(S, 3))

  m <- c(0, 0)
  cr <- diag(2)
  c1 <- matrix(0.5, 2, 2) + 0.5 * diag(2)
  c2 <- matrix(0.7, 2, 2) + 0.3 * diag(2)
  c3 <- matrix(0.9, 2, 2) + 0.1 * diag(2)

  for (i in 1:1000) {
    X1 <- rbind(rmvnorm(S, m, c1), rmvnorm(S, m, cr), rmvnorm(S, m, c1))
    X2 <- rbind(rmvnorm(S, m, c2), rmvnorm(S, m, cr), rmvnorm(S, m, c2))
    X3 <- rbind(rmvnorm(S, m, c3), rmvnorm(S, m, cr), rmvnorm(S, m, c3))
  
    m1 <- e.agglo(X1, mem, 1)
    m2 <- e.agglo(X2, mem, 1)
    m3 <- e.agglo(X3, mem, 1)
  
    er1[, i] <- compareCluster(Acorrect, m1$cluster)
    er2[, i] <- compareCluster(Acorrect, m2$cluster)
    er3[, i] <- compareCluster(Acorrect, m3$cluster)
  }

  ## Obtain average Rand Values for each test case as well as standard errors
  ARandAvg1 <- mean(er1[1, ])
  ARandSE1 <- sd(er1[1, ])/sqrt(1000)
  ARandAvg2 <- mean(er2[1, ])
  ARandSE2 <- sd(er2[1, ])/sqrt(1000)
  ARandAvg3 <- mean(er3[1, ])
  ARandSE3 <- sd(er3[1, ])/sqrt(1000)
  
  result <- matrix(0, nrow = 3, ncol = 3)
  colnames(result) <- c("rho", "Average Rand", "Standard Error")

  result[, 1] <- c(0.5, 0.7, 0.9)
  result[, 2] <- c(ARandAvg1, ARandAvg2, ARandAvg3)
  result[, 3] <- c(ARandSE1, ARandSE2, ARandSE3)
  
  print(result)
}
 
