source("clustercompare.R")
library("ecp")
library("mvtnorm")
for (S in c(100, 200, 300)) {
  set.seed(2012)
  er1 <- er2 <- er3 <- matrix(0, ncol = 1000, nrow = 5)
  mem <- rep(1:(3 * S/10), rep(10, 3 * S/10))
  
  correct <- rep(c(1, 2, 3), rep(S, 3))
  Acorrect <- rep(c(1, 2, 1), rep(S, 3))

  M <- c(0, 0)
  M1 <- c(1, 1)
  M2 <- c(2, 2)
  M3 <- c(3, 3)
  cr <- diag(2)
  
  for (i in 1:1000) {
    X1 <- rbind(rmvnorm(S, M, cr), rmvnorm(S, M1, cr), rmvnorm(S, M, cr))
    X2 <- rbind(rmvnorm(S, M, cr), rmvnorm(S, M2, cr), rmvnorm(S, M, cr))
    X3 <- rbind(rmvnorm(S, M, cr), rmvnorm(S, M3, cr), rmvnorm(S, M, cr))
    
    m1 <- e.agglo(X1, mem, 1)
    m2 <- e.agglo(X2, mem, 1)
    m3 <- e.agglo(X3, mem, 1)
    
    er1[, i] <- compareCluster(Acorrect, m1$cluster)
    er2[, i] <- compareCluster(Acorrect, m2$cluster)
    er3[, i] <- compareCluster(Acorrect, m3$cluster)
  }
  
  ## Obtain average Rand Values for each test case as well as standard errors
  ARandAvg1 <- mean(er1[1, ])
  ARandSE1 <- sd(er1[1, ])/sqrt(1000)
  ARandAvg2 <- mean(er2[1, ])
  ARandSE2 <- sd(er2[1, ])/sqrt(1000)
  ARandAvg3 <- mean(er3[1, ])
  ARandSE3 <- sd(er3[1, ])/sqrt(1000)
  
  result <- matrix(0, nrow = 3, ncol = 3)
  colnames(result) <- c("mu", "Average Rand", "Standard Error")
  
  result[, 1] <- c(1, 2, 3)
  result[, 2] <- c(ARandAvg1, ARandAvg2, ARandAvg3)
  result[, 3] <- c(ARandSE1, ARandSE2, ARandSE3)
  
  print(result)
}



 
