source("clustercompare.R")
library("ecp")

for (S in c(50, 100, 200)) {
  set.seed(2012)
  mem <- rep(1:(3 * S/10), rep(10, 3 * S/10))
  er1 <- er2 <- er3 <- matrix(0, nrow = 5, ncol = 1000)
  Acorrect <- rep(c(1, 2, 1), rep(S, 3))
  
  for (i in 1:1000) {
    x1 <- c(rnorm(S), rnorm(S, 1), rnorm(S))
    x1 <- as.matrix(x1)
    x2 <- c(rnorm(S), rnorm(S, 2), rnorm(S))
    x2 <- as.matrix(x2)
    x3 <- c(rnorm(S), rnorm(S, 4), rnorm(S))
    x3 <- as.matrix(x3)
    
    m1 <- e.agglo(x1, mem, 1)
    m2 <- e.agglo(x2, mem, 1)
    m3 <- e.agglo(x3, mem, 1)
  
    er1[, i] <- compareCluster(Acorrect, m1$cluster)
    er2[, i] <- compareCluster(Acorrect, m2$cluster)
    er3[, i] <- compareCluster(Acorrect, m3$cluster)
  }

  ## Obtain average Rand Values for each test case as well as standard errors
  ARandAvg1 <- mean(er1[1, ])
  ARandSE1 <- sd(er1[1, ])/sqrt(1000)
  ARandAvg2 <- mean(er2[1, ])
  ARandSE2 <- sd(er2[1, ])/sqrt(1000)
  ARandAvg3 <- mean(er3[1, ])
  ARandSE3 <- sd(er3[1, ])/sqrt(1000)
  
  result <- matrix(0, nrow = 3, ncol = 3)
  colnames(result) <- c("mu", "Average Rand", "Standard Error")
  
  result[, 1] <- c(1, 2, 4)
  result[, 2] <- c(ARandAvg1, ARandAvg2, ARandAvg3)
  result[, 3] <- c(ARandSE1, ARandSE2, ARandSE3)
  
  print(result)
}

