source("clustercompare.R")
library("ecp")

for (S in c(50, 100, 200)) {
  set.seed(2012)
  er1 <- er2 <- er3 <- matrix(0, nrow = 5, ncol = 1000)
  Acorrect <- rep(c(1, 2, 1), rep(S, 3))
  mem <- rep(1:(3 * S/10), rep(10, 3 * S/10))

  for (i in 1:1000) {
    X1 <- rbind(as.matrix(rnorm(S)), as.matrix(rt(S, df = 16)), as.matrix(rnorm(S)))
    X2 <- rbind(as.matrix(rnorm(S)), as.matrix(rt(S, df = 8)), as.matrix(rnorm(S)))
    X3 <- rbind(as.matrix(rnorm(S)), as.matrix(rt(S, df = 2)), as.matrix(rnorm(S)))
    
    m1 <- e.agglo(X1, mem, 1)
    m2 <- e.agglo(X2, mem, 1)
    m3 <- e.agglo(X3, mem, 1)

    er1[, i] <- compareCluster(Acorrect, m1$cluster)
    er2[, i] <- compareCluster(Acorrect, m2$cluster)
    er3[, i] <- compareCluster(Acorrect, m3$cluster)
  }
  
  ## Obtain average Rand Values for each test case as well as standard errors
  ARandAvg1 <- mean(er1[1, ])
  ARandSE1 <- sd(er1[1, ])/sqrt(1000)
  ARandAvg2 <- mean(er2[1, ])
  ARandSE2 <- sd(er2[1, ])/sqrt(1000)
  ARandAvg3 <- mean(er3[1, ])
  ARandSE3 <- sd(er3[1, ])/sqrt(1000)
  
  result <- matrix(0, nrow = 3, ncol = 3)
  colnames(result) <- c("Tail Index", "Average Rand", "Standard Error")
  
  result[, 1] <- c(16, 8, 2)
  result[, 2] <- c(ARandAvg1, ARandAvg2, ARandAvg3)
  result[, 3] <- c(ARandSE1, ARandSE2, ARandSE3)
  
  print(result)
}
