source("clustercompare.R")
library("ecp")

for (S in c(50, 100, 200)) {
  set.seed(2012)
  er1 <- er2 <- er3 <- matrix(0, nrow = 5, ncol = 1000)
  correct <- rep(c(1, 2, 3), rep(S, 3))

  for (i in 1:1000) {
    x1 <- c(rnorm(S), rnorm(S, 1), rnorm(S))
    x1 <- as.matrix(x1)
    x2 <- c(rnorm(S), rnorm(S, 2), rnorm(S))
    x2 <- as.matrix(x2)
    x3 <- c(rnorm(S), rnorm(S, 4), rnorm(S))
    x3 <- as.matrix(x3)
    
    e1 <- e.divisive(x1, R = 499)
    e2 <- e.divisive(x2, R = 499)
    e3 <- e.divisive(x3, R = 499)
    
    er1[, i] <- compareCluster(correct, e1$cluster)
    er2[, i] <- compareCluster(correct, e2$cluster)
    er3[, i] <- compareCluster(correct, e3$cluster)
  }
  
  ## Obtain average Rand Values for each test case as well as standard errors
  ERandAvg1 <- mean(er1[1, ])
  ERandSE1 <- sd(er1[1, ])/sqrt(1000)
  ERandAvg2 <- mean(er2[1, ])
  ERandSE2 <- sd(er2[1, ])/sqrt(1000)
  ERandAvg3 <- mean(er3[1, ])
  ERandSE3 <- sd(er3[1, ])/sqrt(1000)
  
  result <- matrix(0, nrow = 3, ncol = 3)
  colnames(result) <- c("mu", "Average Rand", "Standard Error")
  
  result[, 1] <- c(1, 2, 4)
  result[, 2] <- c(ERandAvg1, ERandAvg2, ERandAvg3)
  result[, 3] <- c(ERandSE1, ERandSE2, ERandSE3)
  
  print(result)
}
  
