source("clustercompare.R")
library("ecp")

for (S in c(50, 100, 200)) {
  set.seed(2012)
  er1 <- er2 <- er3 <- matrix(0, nrow = 5, ncol = 1000)
  correct <- rep(c(1, 2, 3), rep(S, 3))

  for (i in 1:1000) {
    x1 <- rbind(as.matrix(rnorm(S)), as.matrix(rt(S, df = 16)), as.matrix(rnorm(S)))
    x2 <- rbind(as.matrix(rnorm(S)), as.matrix(rt(S, df = 8)), as.matrix(rnorm(S)))
    x3 <- rbind(as.matrix(rnorm(S)), as.matrix(rt(S, df = 2)), as.matrix(rnorm(S)))
    
    e1 <- e.divisive(x1, R = 499)
    e2 <- e.divisive(x2, R = 499)
    e3 <- e.divisive(x3, R = 499)
    
    er1[, i] <- compareCluster(correct, e1$cluster)
    er2[, i] <- compareCluster(correct, e2$cluster)
    er3[, i] <- compareCluster(correct, e3$cluster)
  }
  
  ## Obtain average Rand Values for each test case as well as standard errors
  ERandAvg1 <- mean(er1[1, ])
  ERandSE1 <- sd(er1[1, ])/sqrt(1000)
  ERandAvg2 <- mean(er2[1, ])
  ERandSE2 <- sd(er2[1, ])/sqrt(1000)
  ERandAvg3 <- mean(er3[1, ])
  ERandSE3 <- sd(er3[1, ])/sqrt(1000)
  
  result <- matrix(0, nrow = 3, ncol = 3)
  colnames(result) <- c("Tail Index", "Average Rand", "Standard Error")
  
  result[, 1] <- c(16, 8, 2)
  result[, 2] <- c(ERandAvg1, ERandAvg2, ERandAvg3)
  result[, 3] <- c(ERandSE1, ERandSE2, ERandSE3)
  
  print(result)
}
